classification
Title: ARCHFLAGS parsing/concatenation in unixccompiler.py breaks when set to a string
Type: Stage:
Components: Build Versions: Python 2.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: georg.brandl, jnoller
Priority: normal Keywords: patch

Created on 2008-06-12 13:16 by jnoller, last changed 2008-07-16 13:26 by jnoller. This issue is now closed.

Files
File name Uploaded Description Edit
unixccompiler.py.diff jnoller, 2008-06-12 13:16
Messages (4)
msg68061 - (view) Author: Jesse Noller (jnoller) * (Python committer) Date: 2008-06-12 13:16
This is on osx 10.5.3, latest gcc tool chain.

I have $ARCHFLAGS set to "-arch i386" to prevent the OS/X gcc from 
building PPC code (as I don't want/need it) - if I leave this set as-is, 
other applications build without error, intel only.

If I don't unset it, here's the error:

  File "/Users/jesse/open_source/subversion/python-
trunk/Lib/distutils/ccompiler.py", line 697, in compile
self._compile(obj, src, ext, cc_args, extra_postargs, pp_opts)
  File "/Users/jesse/open_source/subversion/python-
trunk/Lib/distutils/unixccompiler.py", line 176, in _compile
compiler_so = _darwin_compiler_fixup(compiler_so, cc_args + 
extra_postargs)
  File "/Users/jesse/open_source/subversion/python-
trunk/Lib/distutils/unixccompiler.py", line 79, in 
_darwin_compiler_fixup
compiler_so = compiler_so + ' ' + os.environ['ARCHFLAGS']
TypeError: can only concatenate list (not "str") to list
make: *** [sharedmods] Error 1

I've attached a possible patch for this which does a .split() on the os.environ['ARCHFLAGS'] variable, which fixes the issue
msg69426 - (view) Author: Jesse Noller (jnoller) * (Python committer) Date: 2008-07-08 12:59
Does anyone have a problem with me committing this patch as-is? It's not a 
show stopper, but it's highly annoying.
msg69748 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2008-07-16 02:33
I'd say go ahead.
msg69785 - (view) Author: Jesse Noller (jnoller) * (Python committer) Date: 2008-07-16 13:26
This has been applied as of r65012 on trunk
History
Date User Action Args
2008-07-16 13:26:24jnollersetstatus: open -> closed
resolution: accepted -> fixed
messages: + msg69785
2008-07-16 02:33:36georg.brandlsetresolution: accepted
messages: + msg69748
nosy: + georg.brandl
2008-07-08 12:59:53jnollersetmessages: + msg69426
2008-06-12 13:16:22jnollercreate